// Code generated by go-swagger; DO NOT EDIT.

package global_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"
	"fmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// CreateGlobalServiceReader is a Reader for the CreateGlobalService structure.
type CreateGlobalServiceReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *CreateGlobalServiceReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewCreateGlobalServiceOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewCreateGlobalServiceOK creates a CreateGlobalServiceOK with default headers values
func NewCreateGlobalServiceOK() *CreateGlobalServiceOK {
	return &CreateGlobalServiceOK{}
}

/* CreateGlobalServiceOK describes a response with status code 200, with default header values.

successfully created service
*/
type CreateGlobalServiceOK struct {
}

func (o *CreateGlobalServiceOK) Error() string {
	return fmt.Sprintf("[POST /api/functions][%d] createGlobalServiceOK ", 200)
}

func (o *CreateGlobalServiceOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

/*CreateGlobalServiceBody create global service body
// Example: {"cmd":"","image":"direktiv/request:v12","minScale":"1","name":"fast-request","size":"small"}
swagger:model CreateGlobalServiceBody
*/
type CreateGlobalServiceBody struct {

	// cmd
	// Required: true
	Cmd *string `json:"cmd"`

	// Target image a service will use
	// Required: true
	Image *string `json:"image"`

	// Minimum amount of service pods to be live
	// Required: true
	MinScale *int64 `json:"minScale"`

	// Name of new service
	// Required: true
	Name *string `json:"name"`

	// Size of created service pods
	// Required: true
	// Enum: [small medium large]
	Size *string `json:"size"`
}

// Validate validates this create global service body
func (o *CreateGlobalServiceBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateCmd(formats); err != nil {
		res = append(res, err)
	}

	if err := o.validateImage(formats); err != nil {
		res = append(res, err)
	}

	if err := o.validateMinScale(formats); err != nil {
		res = append(res, err)
	}

	if err := o.validateName(formats); err != nil {
		res = append(res, err)
	}

	if err := o.validateSize(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *CreateGlobalServiceBody) validateCmd(formats strfmt.Registry) error {

	if err := validate.Required("Service"+"."+"cmd", "body", o.Cmd); err != nil {
		return err
	}

	return nil
}

func (o *CreateGlobalServiceBody) validateImage(formats strfmt.Registry) error {

	if err := validate.Required("Service"+"."+"image", "body", o.Image); err != nil {
		return err
	}

	return nil
}

func (o *CreateGlobalServiceBody) validateMinScale(formats strfmt.Registry) error {

	if err := validate.Required("Service"+"."+"minScale", "body", o.MinScale); err != nil {
		return err
	}

	return nil
}

func (o *CreateGlobalServiceBody) validateName(formats strfmt.Registry) error {

	if err := validate.Required("Service"+"."+"name", "body", o.Name); err != nil {
		return err
	}

	return nil
}

var createGlobalServiceBodyTypeSizePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["small","medium","large"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		createGlobalServiceBodyTypeSizePropEnum = append(createGlobalServiceBodyTypeSizePropEnum, v)
	}
}

const (

	// CreateGlobalServiceBodySizeSmall captures enum value "small"
	CreateGlobalServiceBodySizeSmall string = "small"

	// CreateGlobalServiceBodySizeMedium captures enum value "medium"
	CreateGlobalServiceBodySizeMedium string = "medium"

	// CreateGlobalServiceBodySizeLarge captures enum value "large"
	CreateGlobalServiceBodySizeLarge string = "large"
)

// prop value enum
func (o *CreateGlobalServiceBody) validateSizeEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, createGlobalServiceBodyTypeSizePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (o *CreateGlobalServiceBody) validateSize(formats strfmt.Registry) error {

	if err := validate.Required("Service"+"."+"size", "body", o.Size); err != nil {
		return err
	}

	// value enum
	if err := o.validateSizeEnum("Service"+"."+"size", "body", *o.Size); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this create global service body based on context it is used
func (o *CreateGlobalServiceBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (o *CreateGlobalServiceBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *CreateGlobalServiceBody) UnmarshalBinary(b []byte) error {
	var res CreateGlobalServiceBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
