// Code generated by go-swagger; DO NOT EDIT.

package metrics

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewWorkflowMetricsSankeyParams creates a new WorkflowMetricsSankeyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewWorkflowMetricsSankeyParams() *WorkflowMetricsSankeyParams {
	return &WorkflowMetricsSankeyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewWorkflowMetricsSankeyParamsWithTimeout creates a new WorkflowMetricsSankeyParams object
// with the ability to set a timeout on a request.
func NewWorkflowMetricsSankeyParamsWithTimeout(timeout time.Duration) *WorkflowMetricsSankeyParams {
	return &WorkflowMetricsSankeyParams{
		timeout: timeout,
	}
}

// NewWorkflowMetricsSankeyParamsWithContext creates a new WorkflowMetricsSankeyParams object
// with the ability to set a context for a request.
func NewWorkflowMetricsSankeyParamsWithContext(ctx context.Context) *WorkflowMetricsSankeyParams {
	return &WorkflowMetricsSankeyParams{
		Context: ctx,
	}
}

// NewWorkflowMetricsSankeyParamsWithHTTPClient creates a new WorkflowMetricsSankeyParams object
// with the ability to set a custom HTTPClient for a request.
func NewWorkflowMetricsSankeyParamsWithHTTPClient(client *http.Client) *WorkflowMetricsSankeyParams {
	return &WorkflowMetricsSankeyParams{
		HTTPClient: client,
	}
}

/* WorkflowMetricsSankeyParams contains all the parameters to send to the API endpoint
   for the workflow metrics sankey operation.

   Typically these are written to a http.Request.
*/
type WorkflowMetricsSankeyParams struct {

	/* Namespace.

	   target namespace
	*/
	Namespace string

	/* Ref.

	   target workflow revision reference
	*/
	Ref *string

	/* Workflow.

	   path to target workflow
	*/
	Workflow string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the workflow metrics sankey params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WorkflowMetricsSankeyParams) WithDefaults() *WorkflowMetricsSankeyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the workflow metrics sankey params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WorkflowMetricsSankeyParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the workflow metrics sankey params
func (o *WorkflowMetricsSankeyParams) WithTimeout(timeout time.Duration) *WorkflowMetricsSankeyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the workflow metrics sankey params
func (o *WorkflowMetricsSankeyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the workflow metrics sankey params
func (o *WorkflowMetricsSankeyParams) WithContext(ctx context.Context) *WorkflowMetricsSankeyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the workflow metrics sankey params
func (o *WorkflowMetricsSankeyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the workflow metrics sankey params
func (o *WorkflowMetricsSankeyParams) WithHTTPClient(client *http.Client) *WorkflowMetricsSankeyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the workflow metrics sankey params
func (o *WorkflowMetricsSankeyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithNamespace adds the namespace to the workflow metrics sankey params
func (o *WorkflowMetricsSankeyParams) WithNamespace(namespace string) *WorkflowMetricsSankeyParams {
	o.SetNamespace(namespace)
	return o
}

// SetNamespace adds the namespace to the workflow metrics sankey params
func (o *WorkflowMetricsSankeyParams) SetNamespace(namespace string) {
	o.Namespace = namespace
}

// WithRef adds the ref to the workflow metrics sankey params
func (o *WorkflowMetricsSankeyParams) WithRef(ref *string) *WorkflowMetricsSankeyParams {
	o.SetRef(ref)
	return o
}

// SetRef adds the ref to the workflow metrics sankey params
func (o *WorkflowMetricsSankeyParams) SetRef(ref *string) {
	o.Ref = ref
}

// WithWorkflow adds the workflow to the workflow metrics sankey params
func (o *WorkflowMetricsSankeyParams) WithWorkflow(workflow string) *WorkflowMetricsSankeyParams {
	o.SetWorkflow(workflow)
	return o
}

// SetWorkflow adds the workflow to the workflow metrics sankey params
func (o *WorkflowMetricsSankeyParams) SetWorkflow(workflow string) {
	o.Workflow = workflow
}

// WriteToRequest writes these params to a swagger request
func (o *WorkflowMetricsSankeyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param namespace
	if err := r.SetPathParam("namespace", o.Namespace); err != nil {
		return err
	}

	if o.Ref != nil {

		// query param ref
		var qrRef string

		if o.Ref != nil {
			qrRef = *o.Ref
		}
		qRef := qrRef
		if qRef != "" {

			if err := r.SetQueryParam("ref", qRef); err != nil {
				return err
			}
		}
	}

	// path param workflow
	if err := r.SetPathParam("workflow", o.Workflow); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
