// Code generated by go-swagger; DO NOT EDIT.

package namespace_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewDeleteNamespaceServiceParams creates a new DeleteNamespaceServiceParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeleteNamespaceServiceParams() *DeleteNamespaceServiceParams {
	return &DeleteNamespaceServiceParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteNamespaceServiceParamsWithTimeout creates a new DeleteNamespaceServiceParams object
// with the ability to set a timeout on a request.
func NewDeleteNamespaceServiceParamsWithTimeout(timeout time.Duration) *DeleteNamespaceServiceParams {
	return &DeleteNamespaceServiceParams{
		timeout: timeout,
	}
}

// NewDeleteNamespaceServiceParamsWithContext creates a new DeleteNamespaceServiceParams object
// with the ability to set a context for a request.
func NewDeleteNamespaceServiceParamsWithContext(ctx context.Context) *DeleteNamespaceServiceParams {
	return &DeleteNamespaceServiceParams{
		Context: ctx,
	}
}

// NewDeleteNamespaceServiceParamsWithHTTPClient creates a new DeleteNamespaceServiceParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeleteNamespaceServiceParamsWithHTTPClient(client *http.Client) *DeleteNamespaceServiceParams {
	return &DeleteNamespaceServiceParams{
		HTTPClient: client,
	}
}

/* DeleteNamespaceServiceParams contains all the parameters to send to the API endpoint
   for the delete namespace service operation.

   Typically these are written to a http.Request.
*/
type DeleteNamespaceServiceParams struct {

	/* Namespace.

	   target namespace
	*/
	Namespace string

	/* ServiceName.

	   target service name
	*/
	ServiceName string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete namespace service params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteNamespaceServiceParams) WithDefaults() *DeleteNamespaceServiceParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete namespace service params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteNamespaceServiceParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the delete namespace service params
func (o *DeleteNamespaceServiceParams) WithTimeout(timeout time.Duration) *DeleteNamespaceServiceParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete namespace service params
func (o *DeleteNamespaceServiceParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete namespace service params
func (o *DeleteNamespaceServiceParams) WithContext(ctx context.Context) *DeleteNamespaceServiceParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete namespace service params
func (o *DeleteNamespaceServiceParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete namespace service params
func (o *DeleteNamespaceServiceParams) WithHTTPClient(client *http.Client) *DeleteNamespaceServiceParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete namespace service params
func (o *DeleteNamespaceServiceParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithNamespace adds the namespace to the delete namespace service params
func (o *DeleteNamespaceServiceParams) WithNamespace(namespace string) *DeleteNamespaceServiceParams {
	o.SetNamespace(namespace)
	return o
}

// SetNamespace adds the namespace to the delete namespace service params
func (o *DeleteNamespaceServiceParams) SetNamespace(namespace string) {
	o.Namespace = namespace
}

// WithServiceName adds the serviceName to the delete namespace service params
func (o *DeleteNamespaceServiceParams) WithServiceName(serviceName string) *DeleteNamespaceServiceParams {
	o.SetServiceName(serviceName)
	return o
}

// SetServiceName adds the serviceName to the delete namespace service params
func (o *DeleteNamespaceServiceParams) SetServiceName(serviceName string) {
	o.ServiceName = serviceName
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteNamespaceServiceParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param namespace
	if err := r.SetPathParam("namespace", o.Namespace); err != nil {
		return err
	}

	// path param serviceName
	if err := r.SetPathParam("serviceName", o.ServiceName); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
