// Code generated by go-swagger; DO NOT EDIT.

package registries

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewCreateGlobalPrivateRegistryParams creates a new CreateGlobalPrivateRegistryParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateGlobalPrivateRegistryParams() *CreateGlobalPrivateRegistryParams {
	return &CreateGlobalPrivateRegistryParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateGlobalPrivateRegistryParamsWithTimeout creates a new CreateGlobalPrivateRegistryParams object
// with the ability to set a timeout on a request.
func NewCreateGlobalPrivateRegistryParamsWithTimeout(timeout time.Duration) *CreateGlobalPrivateRegistryParams {
	return &CreateGlobalPrivateRegistryParams{
		timeout: timeout,
	}
}

// NewCreateGlobalPrivateRegistryParamsWithContext creates a new CreateGlobalPrivateRegistryParams object
// with the ability to set a context for a request.
func NewCreateGlobalPrivateRegistryParamsWithContext(ctx context.Context) *CreateGlobalPrivateRegistryParams {
	return &CreateGlobalPrivateRegistryParams{
		Context: ctx,
	}
}

// NewCreateGlobalPrivateRegistryParamsWithHTTPClient creates a new CreateGlobalPrivateRegistryParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateGlobalPrivateRegistryParamsWithHTTPClient(client *http.Client) *CreateGlobalPrivateRegistryParams {
	return &CreateGlobalPrivateRegistryParams{
		HTTPClient: client,
	}
}

/* CreateGlobalPrivateRegistryParams contains all the parameters to send to the API endpoint
   for the create global private registry operation.

   Typically these are written to a http.Request.
*/
type CreateGlobalPrivateRegistryParams struct {

	/* RegistryPayload.

	   Payload that contains registry data
	*/
	RegistryPayload CreateGlobalPrivateRegistryBody

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create global private registry params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateGlobalPrivateRegistryParams) WithDefaults() *CreateGlobalPrivateRegistryParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create global private registry params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateGlobalPrivateRegistryParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create global private registry params
func (o *CreateGlobalPrivateRegistryParams) WithTimeout(timeout time.Duration) *CreateGlobalPrivateRegistryParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create global private registry params
func (o *CreateGlobalPrivateRegistryParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create global private registry params
func (o *CreateGlobalPrivateRegistryParams) WithContext(ctx context.Context) *CreateGlobalPrivateRegistryParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create global private registry params
func (o *CreateGlobalPrivateRegistryParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create global private registry params
func (o *CreateGlobalPrivateRegistryParams) WithHTTPClient(client *http.Client) *CreateGlobalPrivateRegistryParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create global private registry params
func (o *CreateGlobalPrivateRegistryParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithRegistryPayload adds the registryPayload to the create global private registry params
func (o *CreateGlobalPrivateRegistryParams) WithRegistryPayload(registryPayload CreateGlobalPrivateRegistryBody) *CreateGlobalPrivateRegistryParams {
	o.SetRegistryPayload(registryPayload)
	return o
}

// SetRegistryPayload adds the registryPayload to the create global private registry params
func (o *CreateGlobalPrivateRegistryParams) SetRegistryPayload(registryPayload CreateGlobalPrivateRegistryBody) {
	o.RegistryPayload = registryPayload
}

// WriteToRequest writes these params to a swagger request
func (o *CreateGlobalPrivateRegistryParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.RegistryPayload); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
