// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"database/sql/driver"
	"fmt"
	"math"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/direktiv/direktiv/pkg/flow/ent/predicate"
	"github.com/direktiv/direktiv/pkg/flow/ent/vardata"
	"github.com/direktiv/direktiv/pkg/flow/ent/varref"
	"github.com/google/uuid"
)

// VarDataQuery is the builder for querying VarData entities.
type VarDataQuery struct {
	config
	limit      *int
	offset     *int
	unique     *bool
	order      []OrderFunc
	fields     []string
	predicates []predicate.VarData
	// eager-loading edges.
	withVarrefs *VarRefQuery
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the VarDataQuery builder.
func (vdq *VarDataQuery) Where(ps ...predicate.VarData) *VarDataQuery {
	vdq.predicates = append(vdq.predicates, ps...)
	return vdq
}

// Limit adds a limit step to the query.
func (vdq *VarDataQuery) Limit(limit int) *VarDataQuery {
	vdq.limit = &limit
	return vdq
}

// Offset adds an offset step to the query.
func (vdq *VarDataQuery) Offset(offset int) *VarDataQuery {
	vdq.offset = &offset
	return vdq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (vdq *VarDataQuery) Unique(unique bool) *VarDataQuery {
	vdq.unique = &unique
	return vdq
}

// Order adds an order step to the query.
func (vdq *VarDataQuery) Order(o ...OrderFunc) *VarDataQuery {
	vdq.order = append(vdq.order, o...)
	return vdq
}

// QueryVarrefs chains the current query on the "varrefs" edge.
func (vdq *VarDataQuery) QueryVarrefs() *VarRefQuery {
	query := &VarRefQuery{config: vdq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := vdq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := vdq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(vardata.Table, vardata.FieldID, selector),
			sqlgraph.To(varref.Table, varref.FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, vardata.VarrefsTable, vardata.VarrefsColumn),
		)
		fromU = sqlgraph.SetNeighbors(vdq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// First returns the first VarData entity from the query.
// Returns a *NotFoundError when no VarData was found.
func (vdq *VarDataQuery) First(ctx context.Context) (*VarData, error) {
	nodes, err := vdq.Limit(1).All(ctx)
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{vardata.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (vdq *VarDataQuery) FirstX(ctx context.Context) *VarData {
	node, err := vdq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first VarData ID from the query.
// Returns a *NotFoundError when no VarData ID was found.
func (vdq *VarDataQuery) FirstID(ctx context.Context) (id uuid.UUID, err error) {
	var ids []uuid.UUID
	if ids, err = vdq.Limit(1).IDs(ctx); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{vardata.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (vdq *VarDataQuery) FirstIDX(ctx context.Context) uuid.UUID {
	id, err := vdq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single VarData entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when more than one VarData entity is found.
// Returns a *NotFoundError when no VarData entities are found.
func (vdq *VarDataQuery) Only(ctx context.Context) (*VarData, error) {
	nodes, err := vdq.Limit(2).All(ctx)
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{vardata.Label}
	default:
		return nil, &NotSingularError{vardata.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (vdq *VarDataQuery) OnlyX(ctx context.Context) *VarData {
	node, err := vdq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only VarData ID in the query.
// Returns a *NotSingularError when more than one VarData ID is found.
// Returns a *NotFoundError when no entities are found.
func (vdq *VarDataQuery) OnlyID(ctx context.Context) (id uuid.UUID, err error) {
	var ids []uuid.UUID
	if ids, err = vdq.Limit(2).IDs(ctx); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{vardata.Label}
	default:
		err = &NotSingularError{vardata.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (vdq *VarDataQuery) OnlyIDX(ctx context.Context) uuid.UUID {
	id, err := vdq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of VarDataSlice.
func (vdq *VarDataQuery) All(ctx context.Context) ([]*VarData, error) {
	if err := vdq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	return vdq.sqlAll(ctx)
}

// AllX is like All, but panics if an error occurs.
func (vdq *VarDataQuery) AllX(ctx context.Context) []*VarData {
	nodes, err := vdq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of VarData IDs.
func (vdq *VarDataQuery) IDs(ctx context.Context) ([]uuid.UUID, error) {
	var ids []uuid.UUID
	if err := vdq.Select(vardata.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (vdq *VarDataQuery) IDsX(ctx context.Context) []uuid.UUID {
	ids, err := vdq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (vdq *VarDataQuery) Count(ctx context.Context) (int, error) {
	if err := vdq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return vdq.sqlCount(ctx)
}

// CountX is like Count, but panics if an error occurs.
func (vdq *VarDataQuery) CountX(ctx context.Context) int {
	count, err := vdq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (vdq *VarDataQuery) Exist(ctx context.Context) (bool, error) {
	if err := vdq.prepareQuery(ctx); err != nil {
		return false, err
	}
	return vdq.sqlExist(ctx)
}

// ExistX is like Exist, but panics if an error occurs.
func (vdq *VarDataQuery) ExistX(ctx context.Context) bool {
	exist, err := vdq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the VarDataQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (vdq *VarDataQuery) Clone() *VarDataQuery {
	if vdq == nil {
		return nil
	}
	return &VarDataQuery{
		config:      vdq.config,
		limit:       vdq.limit,
		offset:      vdq.offset,
		order:       append([]OrderFunc{}, vdq.order...),
		predicates:  append([]predicate.VarData{}, vdq.predicates...),
		withVarrefs: vdq.withVarrefs.Clone(),
		// clone intermediate query.
		sql:    vdq.sql.Clone(),
		path:   vdq.path,
		unique: vdq.unique,
	}
}

// WithVarrefs tells the query-builder to eager-load the nodes that are connected to
// the "varrefs" edge. The optional arguments are used to configure the query builder of the edge.
func (vdq *VarDataQuery) WithVarrefs(opts ...func(*VarRefQuery)) *VarDataQuery {
	query := &VarRefQuery{config: vdq.config}
	for _, opt := range opts {
		opt(query)
	}
	vdq.withVarrefs = query
	return vdq
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
//
// Example:
//
//	var v []struct {
//		CreatedAt time.Time `json:"created_at,omitempty"`
//		Count int `json:"count,omitempty"`
//	}
//
//	client.VarData.Query().
//		GroupBy(vardata.FieldCreatedAt).
//		Aggregate(ent.Count()).
//		Scan(ctx, &v)
//
func (vdq *VarDataQuery) GroupBy(field string, fields ...string) *VarDataGroupBy {
	grbuild := &VarDataGroupBy{config: vdq.config}
	grbuild.fields = append([]string{field}, fields...)
	grbuild.path = func(ctx context.Context) (prev *sql.Selector, err error) {
		if err := vdq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		return vdq.sqlQuery(ctx), nil
	}
	grbuild.label = vardata.Label
	grbuild.flds, grbuild.scan = &grbuild.fields, grbuild.Scan
	return grbuild
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
//
// Example:
//
//	var v []struct {
//		CreatedAt time.Time `json:"created_at,omitempty"`
//	}
//
//	client.VarData.Query().
//		Select(vardata.FieldCreatedAt).
//		Scan(ctx, &v)
//
func (vdq *VarDataQuery) Select(fields ...string) *VarDataSelect {
	vdq.fields = append(vdq.fields, fields...)
	selbuild := &VarDataSelect{VarDataQuery: vdq}
	selbuild.label = vardata.Label
	selbuild.flds, selbuild.scan = &vdq.fields, selbuild.Scan
	return selbuild
}

func (vdq *VarDataQuery) prepareQuery(ctx context.Context) error {
	for _, f := range vdq.fields {
		if !vardata.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if vdq.path != nil {
		prev, err := vdq.path(ctx)
		if err != nil {
			return err
		}
		vdq.sql = prev
	}
	return nil
}

func (vdq *VarDataQuery) sqlAll(ctx context.Context, hooks ...queryHook) ([]*VarData, error) {
	var (
		nodes       = []*VarData{}
		_spec       = vdq.querySpec()
		loadedTypes = [1]bool{
			vdq.withVarrefs != nil,
		}
	)
	_spec.ScanValues = func(columns []string) ([]interface{}, error) {
		return (*VarData).scanValues(nil, columns)
	}
	_spec.Assign = func(columns []string, values []interface{}) error {
		node := &VarData{config: vdq.config}
		nodes = append(nodes, node)
		node.Edges.loadedTypes = loadedTypes
		return node.assignValues(columns, values)
	}
	for i := range hooks {
		hooks[i](ctx, _spec)
	}
	if err := sqlgraph.QueryNodes(ctx, vdq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}

	if query := vdq.withVarrefs; query != nil {
		fks := make([]driver.Value, 0, len(nodes))
		nodeids := make(map[uuid.UUID]*VarData)
		for i := range nodes {
			fks = append(fks, nodes[i].ID)
			nodeids[nodes[i].ID] = nodes[i]
			nodes[i].Edges.Varrefs = []*VarRef{}
		}
		query.withFKs = true
		query.Where(predicate.VarRef(func(s *sql.Selector) {
			s.Where(sql.InValues(vardata.VarrefsColumn, fks...))
		}))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			fk := n.var_data_varrefs
			if fk == nil {
				return nil, fmt.Errorf(`foreign-key "var_data_varrefs" is nil for node %v`, n.ID)
			}
			node, ok := nodeids[*fk]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "var_data_varrefs" returned %v for node %v`, *fk, n.ID)
			}
			node.Edges.Varrefs = append(node.Edges.Varrefs, n)
		}
	}

	return nodes, nil
}

func (vdq *VarDataQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := vdq.querySpec()
	_spec.Node.Columns = vdq.fields
	if len(vdq.fields) > 0 {
		_spec.Unique = vdq.unique != nil && *vdq.unique
	}
	return sqlgraph.CountNodes(ctx, vdq.driver, _spec)
}

func (vdq *VarDataQuery) sqlExist(ctx context.Context) (bool, error) {
	n, err := vdq.sqlCount(ctx)
	if err != nil {
		return false, fmt.Errorf("ent: check existence: %w", err)
	}
	return n > 0, nil
}

func (vdq *VarDataQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := &sqlgraph.QuerySpec{
		Node: &sqlgraph.NodeSpec{
			Table:   vardata.Table,
			Columns: vardata.Columns,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeUUID,
				Column: vardata.FieldID,
			},
		},
		From:   vdq.sql,
		Unique: true,
	}
	if unique := vdq.unique; unique != nil {
		_spec.Unique = *unique
	}
	if fields := vdq.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, vardata.FieldID)
		for i := range fields {
			if fields[i] != vardata.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
	}
	if ps := vdq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := vdq.limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := vdq.offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := vdq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (vdq *VarDataQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(vdq.driver.Dialect())
	t1 := builder.Table(vardata.Table)
	columns := vdq.fields
	if len(columns) == 0 {
		columns = vardata.Columns
	}
	selector := builder.Select(t1.Columns(columns...)...).From(t1)
	if vdq.sql != nil {
		selector = vdq.sql
		selector.Select(selector.Columns(columns...)...)
	}
	if vdq.unique != nil && *vdq.unique {
		selector.Distinct()
	}
	for _, p := range vdq.predicates {
		p(selector)
	}
	for _, p := range vdq.order {
		p(selector)
	}
	if offset := vdq.offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := vdq.limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// VarDataGroupBy is the group-by builder for VarData entities.
type VarDataGroupBy struct {
	config
	selector
	fields []string
	fns    []AggregateFunc
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Aggregate adds the given aggregation functions to the group-by query.
func (vdgb *VarDataGroupBy) Aggregate(fns ...AggregateFunc) *VarDataGroupBy {
	vdgb.fns = append(vdgb.fns, fns...)
	return vdgb
}

// Scan applies the group-by query and scans the result into the given value.
func (vdgb *VarDataGroupBy) Scan(ctx context.Context, v interface{}) error {
	query, err := vdgb.path(ctx)
	if err != nil {
		return err
	}
	vdgb.sql = query
	return vdgb.sqlScan(ctx, v)
}

func (vdgb *VarDataGroupBy) sqlScan(ctx context.Context, v interface{}) error {
	for _, f := range vdgb.fields {
		if !vardata.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("invalid field %q for group-by", f)}
		}
	}
	selector := vdgb.sqlQuery()
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := vdgb.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

func (vdgb *VarDataGroupBy) sqlQuery() *sql.Selector {
	selector := vdgb.sql.Select()
	aggregation := make([]string, 0, len(vdgb.fns))
	for _, fn := range vdgb.fns {
		aggregation = append(aggregation, fn(selector))
	}
	// If no columns were selected in a custom aggregation function, the default
	// selection is the fields used for "group-by", and the aggregation functions.
	if len(selector.SelectedColumns()) == 0 {
		columns := make([]string, 0, len(vdgb.fields)+len(vdgb.fns))
		for _, f := range vdgb.fields {
			columns = append(columns, selector.C(f))
		}
		columns = append(columns, aggregation...)
		selector.Select(columns...)
	}
	return selector.GroupBy(selector.Columns(vdgb.fields...)...)
}

// VarDataSelect is the builder for selecting fields of VarData entities.
type VarDataSelect struct {
	*VarDataQuery
	selector
	// intermediate query (i.e. traversal path).
	sql *sql.Selector
}

// Scan applies the selector query and scans the result into the given value.
func (vds *VarDataSelect) Scan(ctx context.Context, v interface{}) error {
	if err := vds.prepareQuery(ctx); err != nil {
		return err
	}
	vds.sql = vds.VarDataQuery.sqlQuery(ctx)
	return vds.sqlScan(ctx, v)
}

func (vds *VarDataSelect) sqlScan(ctx context.Context, v interface{}) error {
	rows := &sql.Rows{}
	query, args := vds.sql.Query()
	if err := vds.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}
